Last Comment Bug 315562 - non-MOZILLA_INTERNAL_API code usage of dom/content headers
: non-MOZILLA_INTERNAL_API code usage of dom/content headers
Status: RESOLVED FIXED
:
Product: Core
Classification: Components
Component: DOM (show other bugs)
: Trunk
: All All
: P2 normal (vote)
: mozilla1.9alpha1
Assigned To: Benjamin Smedberg [:bsmedberg]
: Hixie (not reading bugmail)
Mentors:
Depends on:
Blocks: 305949 315563
  Show dependency treegraph
 
Reported: 2005-11-08 07:59 PST by Benjamin Smedberg [:bsmedberg]
Modified: 2005-11-16 12:31 PST (History)
3 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
Hack "nsStringGlue.h" and ifdefs for non-internal API use (5.47 KB, patch)
2005-11-08 08:01 PST, Benjamin Smedberg [:bsmedberg]
no flags Details | Diff | Review
Hack "nsStringGlue.h" and ifdefs for non-internal API use (6.28 KB, patch)
2005-11-08 11:33 PST, Benjamin Smedberg [:bsmedberg]
jst: review+
Details | Diff | Review

Description Benjamin Smedberg [:bsmedberg] 2005-11-08 07:59:00 PST
The Mozilla activex plugin/control needs to be built without MOZILLA_INTERNAL_API, but it needs to include nsIContent.h so it can pass a content object to nsILinkHandler. The forthcoming patch is a hack that allows the necessary headers to be included without breaking the build.
Comment 1 Benjamin Smedberg [:bsmedberg] 2005-11-08 08:01:00 PST
Created attachment 202252 [details] [diff] [review]
Hack "nsStringGlue.h" and ifdefs for non-internal API use
Comment 2 Darin Fisher 2005-11-08 10:17:33 PST
Comment on attachment 202252 [details] [diff] [review]
Hack "nsStringGlue.h" and ifdefs for non-internal API use

>Index: content/base/public/nsIDocument.h

>+#ifndef MOZILLA_INTERNAL_API
>+// XXX Hack alert! These are only here to make this file compile, you can't
>+// actually use these to do anything useful with the frozen string API.
>+#define nsAFlatString nsAString
>+#define nsAFlatCString nsACString
>+#endif

nsAFlatString is a deprecated type even in the internal string API, and
it actually corresponds to nsString.  Why not add typedefs to nsStringAPI.h
in the deprecated section for this?  Or, change nsIDocument to use nsString
in place of nsAFlatString.
Comment 3 Benjamin Smedberg [:bsmedberg] 2005-11-08 11:33:16 PST
Created attachment 202287 [details] [diff] [review]
Hack "nsStringGlue.h" and ifdefs for non-internal API use
Comment 4 Johnny Stenback (:jst, jst@mozilla.com) 2005-11-15 16:07:20 PST
Comment on attachment 202287 [details] [diff] [review]
Hack "nsStringGlue.h" and ifdefs for non-internal API use

r=jst
Comment 5 Benjamin Smedberg [:bsmedberg] 2005-11-16 12:31:33 PST
Fixed on trunk.

Note You need to log in before you can comment on or make changes to this bug.